import win32com, sys, string, win32api, traceback, re, tempfile, os
import win32com.client
from win32com.test.util import CheckClean
import pythoncom
from win32com.client import gencache
from win32com.client import constants, Dispatch
from pywintypes import Unicode
from stat import *

class MSWordDoc:
	def __init__(self, name, data):
		"Initialization : create tmp work directory and copy the document into a file."
		self.name = name
		self.data = data
		self.tmpdir = tempfile.mktemp()
		os.mkdir(self.tmpdir)
		filedest = open("%s\%s.doc" % (self.tmpdir, self.name), "wb")
		filedest.write(data)
		filedest.close()

	def Convert(self):
		file = "%s\%s.doc" % (self.tmpdir, self.name)
		pythoncom.CoInitialize()
		word = Dispatch("Word.Application")
		htmlformat = constants.wdFormatHTML
		word.Visible = 0
		doc = word.Documents.Open(file)
		#Let's set up some html saving options for this document
		word.ActiveDocument.WebOptions.RelyOnCSS = 1
		word.ActiveDocument.WebOptions.OptimizeForBrowser = 1
		word.ActiveDocument.WebOptions.BrowserLevel = constants.wdBrowserLevelV4
		word.ActiveDocument.WebOptions.OrganizeInFolder = 0
		word.ActiveDocument.WebOptions.UseLongFileNames = 1
		word.ActiveDocument.WebOptions.RelyOnVML = 0
		word.ActiveDocument.WebOptions.AllowPNG = 1
		#And then save the document into HTML
		doc.SaveAs(FileName = "%s\%s.htm" % (self.tmpdir, self.name), FileFormat = constants.wdFormatHTML)
		doc.Close()
		word.Quit()
		win32api.Sleep(1000) #Waiting for Word to close
		pythoncom.CoUninitialize()

## This function has to be done. It's more difficult to delete the temp
## directory under Windows, because there is sometimes a directory in it.
	def cleandir(self):
		for f in os.listdir(self.tmpdir):
			os.remove("%s\%s" % (self.tmpdir, f))
		os.rmdir(self.tmpdir)

	def getDocHTML(self):
		htmlfile = open("%s\%s.htm" % (self.tmpdir, self.name), 'r')
		html = htmlfile.read()
		htmlfile.close()
		return html

	def getImgs(self):
		imgs = []
		for f in os.listdir(self.tmpdir):
			result = re.match("^.+\.(?P<ext>.+)$", f)
			ext = result.group('ext') 
			if ext in ('png', 'jpg', 'gif', 'wmz'): imgs.append(f)
		path = "%s\\" % self.tmpdir
		return path, imgs